/**
 * @copyright 2015 Prometheus Research, LLC
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x2, _x3, _x4) { var _again = true; _function: while (_again) { var object = _x2, property = _x3, receiver = _x4; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x2 = parent; _x3 = property; _x4 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

exports['default'] = styleComponent;

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _DOMStylesheet = require('./DOMStylesheet');

var DOMStylesheet = _interopRequireWildcard(_DOMStylesheet);

var _StyleableDOMComponent2 = require('./StyleableDOMComponent');

var _StyleableDOMComponent3 = _interopRequireDefault(_StyleableDOMComponent2);

var _isValidReactComponent = require('./isValidReactComponent');

var _isValidReactComponent2 = _interopRequireDefault(_isValidReactComponent);

var _getComponentDisplayName = require('./getComponentDisplayName');

var _getComponentDisplayName2 = _interopRequireDefault(_getComponentDisplayName);

/**
 * Apply a stylesheet to a component.
 */

function styleComponent(Component, stylesheet) {
  var name = arguments.length <= 2 || arguments[2] === undefined ? null : arguments[2];

  (0, _invariant2['default'])((0, _isValidReactComponent2['default'])(Component), 'Expected a valid React component, got: %s', typeof Component);
  if (typeof Component.style === 'function') {
    return Component.style(stylesheet);
  } else {
    if (!DOMStylesheet.isValidStylesheet(stylesheet)) {
      name = name || (0, _getComponentDisplayName2['default'])(Component);
      stylesheet = DOMStylesheet.createStylesheet(stylesheet, name);
    }
    return styleDOMComponent(Component, stylesheet);
  }
}

function styleDOMComponent(Component, spec) {
  return (function (_StyleableDOMComponent) {
    _inherits(_class, _StyleableDOMComponent);

    function _class() {
      _classCallCheck(this, _class);

      _get(Object.getPrototypeOf(_class.prototype), 'constructor', this).apply(this, arguments);
    }

    _createClass(_class, null, [{
      key: 'displayName',
      value: 'StyleableDOMComponent(' + (0, _getComponentDisplayName2['default'])(Component) + ')',
      enumerable: true
    }, {
      key: 'Component',
      value: Component,
      enumerable: true
    }, {
      key: 'stylesheet',
      value: spec,
      enumerable: true
    }]);

    return _class;
  })(_StyleableDOMComponent3['default']);
}
module.exports = exports['default'];
